#include <dos.h>
#include <stdio.h>

char *vga = MK_FP(0xA000, 0);			// create a pointer to the screen

void SetMode13h()
{
	union REGS regs;					// variable that allows access to registers
	regs.x.ax = 0x013;					// place 13h in AX register
	int86(0x10, &regs, &regs);			// execute interrupt 10 - set vid mode
}

void SetTextMode()
{
	union REGS regs;					// variable that allows access to registers
	regs.x.ax = 0x003;					// place 3h in AX register
	int86(0x10, &regs, &regs);			// execute interrupt 10
}

void PlotPixel(int x, int y, char colour)
{
	int offset;
	offset = (y*320) +x;			// calculate pixel offset
	*(vga + offset)=colour;			// point to offset from screen pointer
									// and set that byte to colour
}

void main()
{
	int xpos, ypos, colour;				// three variables to store our
										// random values

	SetMode13h();						// set mode13h

	do									// start loop
	{
		xpos = rand() % 320;			// random x position
		ypos = rand() % 200;			// random y position
		colour = rand() % 255;			// random colour
		PlotPixel(xpos, ypos, colour);	// plot the pixel
	}
	while(!kbhit());					// loop until key pressed

	SetTextMode();						// set text mode
}